proc  csdan5(y,x,z,m,w,q,s,p,icase);
local i,n,j,dx,dz,y1,x1,z1,xq,vy,vx,vz,vv,be,t;
local sq1,sq2,x2,z2,y2,x3,y3,z3,www,rr,skk,sk1,sk2;
local skk1,tr01,skk2,tr02,wx,wy,wz,ww,bw1,tw1,bw2,tw2;
local bb,bs,qqs,bbs,rrs,bs1,bs2,ss1,ss2;
local v2,b2;
local sq3,sq4,x4,y4,z4,x5,y5,z5,sk3,sk4,r2,ww2,tr03,tr04,skk3,skk4;
local m1,w1,q1,dm,dw,dq,vm,vw,vq,m2,w2,q2;
local indx,para,ome,res1,sigma;
local sigm1,indxc,sigm2;

n = cols(y); t = rows(y);

       y1 = y[2+s:t-s,.];
       x1 = x[2+s:t-s,.];
       z1 = z[2+s:t-s,.];
       m1 = m[2+s:t-s,.];
       w1 = w[2+s:t-s,.];
       q1 = q[2+s:t-s,.];

       dx = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dz = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dm = zeros(rows(m[2+s:t-s,.]),2*s+1);
       dw = zeros(rows(w[2+s:t-s,.]),2*s+1);
       dq = zeros(rows(q[2+s:t-s,.]),2*s+1);


  i = 1;
  do while i <= n;

    j = 1;
    do while j <= 2*s+1;
       dx[.,j] = x[2*s+3-j:t+1-j,i] - x[2*s+2-j:t-j,i];
       dz[.,j] = z[2*s+3-j:t+1-j,i] - z[2*s+2-j:t-j,i];
       dm[.,j] = m[2*s+3-j:t+1-j,i] - m[2*s+2-j:t-j,i];
       dw[.,j] = w[2*s+3-j:t+1-j,i] - w[2*s+2-j:t-j,i];
       dq[.,j] = q[2*s+3-j:t+1-j,i] - q[2*s+2-j:t-j,i];
    j = j + 1;
    endo;
    
       y1[.,i] = y[2+s:t-s,i];
       x1[.,i] = x[2+s:t-s,i];
       z1[.,i] = z[2+s:t-s,i];
       m1[.,i] = m[2+s:t-s,i];
       w1[.,i] = w[2+s:t-s,i];
       q1[.,i] = q[2+s:t-s,i];

  if icase == 1; xq = dx~dz~dm~dw~dq; endif;
  if icase == 2; xq = ones(rows(dx),1)~dx~dz~dm~dw~dq; endif;
  if icase == 3; xq = ones(rows(dx),1)~seqa(1,1,rows(dx))~dx~dz~dm~dw~dq; endif;

       xq = xq*invpd(xq'xq)*xq';
     y1[.,i] = y1[.,i] - xq*y1[.,i];
     x1[.,i] = x1[.,i] - xq*x1[.,i];
     z1[.,i] = z1[.,i] - xq*z1[.,i];
     m1[.,i] = m1[.,i] - xq*m1[.,i];
     w1[.,i] = w1[.,i] - xq*w1[.,i];
     q1[.,i] = q1[.,i] - xq*q1[.,i];

  i = i + 1;
  endo;

  bb   = zeros(5,n);
  rrs  = y1;
  bs2  = zeros(5,n);

  i = 1;
  do while i <= n;
    qqs = x1[.,i]~z1[.,i]~m1[.,i]~w1[.,i]~q1[.,i];
    bbs = invpd(qqs'qqs)*qqs'y1[.,i];
    rrs[.,i] = y1[.,i] - qqs*bbs;
  i = i + 1;
  endo;

indx = detlag(rrs,p,0);
{sigma} = crox(rrs,indx,p);

sigm1 = abs(sigma);
sigm1 = sigm1 - eye(cols(sigm1));
sigm1 = sumc(sigm1)./(cols(sigm1)-1);

indxc = {};

i = 1;
do while i <= n;
  if sigm1[i] > 0.49; indxc = indxc~i; endif;
i = i + 1;
endo;

if cols(indxc) > 1; 
rrs = rrs[.,indxc];
indx = detlag(rrs,p,0);
{sigm2} = crox(rrs,indx,p);
endif;

format /m1 /rd 4,1;
"";
"";
"";
"";
"";
"";
"";
"";
"";

" __________________ Correlation Matrix for all units_________________";
"";
"";
"     ";;seqa(1,1,cols(y))';
"_____________________________________________________________________";
i = 1;
do while i <= cols(y);
 i;;"|";;sigma[i,.];
i = i + 1;
endo;
"_____________________________________________________________________";
"";
if cols(indxc) < 2;
" No high cross sectional correlation in the data: 
  use common time effects to handle for cross section dependence";
goto mani1;
endif;

if cols(sigm2) > 2; 
" ___________________ Highest Correlation (>= 0.5) units _____________";

"     ";;indxc;
"_____________________________________________________________________";
i = 1;
do while i <= cols(sigm2);
 indxc[i];;"|";;sigm2[i,.];
i = i + 1;
endo;
"_____________________________________________________________________";
"";
endif;
mani1:
retp(indxc);
endp;



proc  csdan4(y,x,z,m,w,s,p,icase);
local i,n,j,dx,dz,y1,x1,z1,xq,vy,vx,vz,vv,be,t;
local sq1,sq2,x2,z2,y2,x3,y3,z3,www,rr,skk,sk1,sk2;
local skk1,tr01,skk2,tr02,wx,wy,wz,ww,bw1,tw1,bw2,tw2;
local bb,bs,qqs,bbs,rrs,bs1,bs2,ss1,ss2;
local v2,b2;
local sq3,sq4,x4,y4,z4,x5,y5,z5,sk3,sk4,r2,ww2,tr03,tr04,skk3,skk4;
local m1,w1,q1,dm,dw,dq,vm,vw,vq,m2,w2,q2;
local indx,para,ome,res1,sigma;
local sigm1,indxc,sigm2;

n = cols(y); t = rows(y);

       y1 = y[2+s:t-s,.];
       x1 = x[2+s:t-s,.];
       z1 = z[2+s:t-s,.];
       m1 = m[2+s:t-s,.];
       w1 = w[2+s:t-s,.];

       dx = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dz = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dm = zeros(rows(m[2+s:t-s,.]),2*s+1);
       dw = zeros(rows(w[2+s:t-s,.]),2*s+1);


  i = 1;
  do while i <= n;

    j = 1;
    do while j <= 2*s+1;
       dx[.,j] = x[2*s+3-j:t+1-j,i] - x[2*s+2-j:t-j,i];
       dz[.,j] = z[2*s+3-j:t+1-j,i] - z[2*s+2-j:t-j,i];
       dm[.,j] = m[2*s+3-j:t+1-j,i] - m[2*s+2-j:t-j,i];
       dw[.,j] = w[2*s+3-j:t+1-j,i] - w[2*s+2-j:t-j,i];
    j = j + 1;
    endo;
    
       y1[.,i] = y[2+s:t-s,i];
       x1[.,i] = x[2+s:t-s,i];
       z1[.,i] = z[2+s:t-s,i];
       m1[.,i] = m[2+s:t-s,i];
       w1[.,i] = w[2+s:t-s,i];

  if icase == 1; xq = dx~dz~dm~dw; endif;
  if icase == 2; xq = ones(rows(dx),1)~dx~dz~dm~dw; endif;
  if icase == 3; xq = ones(rows(dx),1)~seqa(1,1,rows(dx))~dx~dz~dm~dw; endif;

       xq = xq*invpd(xq'xq)*xq';
     y1[.,i] = y1[.,i] - xq*y1[.,i];
     x1[.,i] = x1[.,i] - xq*x1[.,i];
     z1[.,i] = z1[.,i] - xq*z1[.,i];
     m1[.,i] = m1[.,i] - xq*m1[.,i];
     w1[.,i] = w1[.,i] - xq*w1[.,i];

  i = i + 1;
  endo;

  bb   = zeros(5,n);
  rrs  = y1;
  bs2  = zeros(5,n);

  i = 1;
  do while i <= n;
    qqs = x1[.,i]~z1[.,i]~m1[.,i]~w1[.,i];
    bbs = invpd(qqs'qqs)*qqs'y1[.,i];
    rrs[.,i] = y1[.,i] - qqs*bbs;
  i = i + 1;
  endo;

indx = detlag(rrs,p,0);
{sigma} = crox(rrs,indx,p);

sigm1 = abs(sigma);
sigm1 = sigm1 - eye(cols(sigm1));
sigm1 = sumc(sigm1)./(cols(sigm1)-1);

indxc = {};

i = 1;
do while i <= n;
  if sigm1[i] > 0.49; indxc = indxc~i; endif;
i = i + 1;
endo;

if cols(indxc) > 1; 
rrs = rrs[.,indxc];
indx = detlag(rrs,p,0);
{sigm2} = crox(rrs,indx,p);
endif;

format /m1 /rd 4,1;
"";
"";
"";
"";
"";
"";
"";
"";
"";

" __________________ Correlation Matrix for all units_________________";
"";
"";
"     ";;seqa(1,1,cols(y))';
"_____________________________________________________________________";
i = 1;
do while i <= cols(y);
 i;;"|";;sigma[i,.];
i = i + 1;
endo;
"_____________________________________________________________________";
"";
if cols(indxc) < 2;
" No high cross sectional correlation in the data: 
  use common time effects to handle for cross section dependence";
goto mani1;
endif;

if cols(sigm2) > 2; 
" ___________________ Highest Correlation (>= 0.5) units _____________";

"     ";;indxc;
"_____________________________________________________________________";
i = 1;
do while i <= cols(sigm2);
 indxc[i];;"|";;sigm2[i,.];
i = i + 1;
endo;
"_____________________________________________________________________";
"";
endif;
mani1:
retp(indxc);
endp;


proc  csdan3(y,x,z,m,s,p,icase);
local i,n,j,dx,dz,y1,x1,z1,xq,vy,vx,vz,vv,be,t;
local sq1,sq2,x2,z2,y2,x3,y3,z3,www,rr,skk,sk1,sk2;
local skk1,tr01,skk2,tr02,wx,wy,wz,ww,bw1,tw1,bw2,tw2;
local bb,bs,qqs,bbs,rrs,bs1,bs2,ss1,ss2;
local v2,b2;
local sq3,sq4,x4,y4,z4,x5,y5,z5,sk3,sk4,r2,ww2,tr03,tr04,skk3,skk4;
local m1,w1,q1,dm,dw,dq,vm,vw,vq,m2,w2,q2;
local indx,para,ome,res1,sigma;
local sigm1,indxc,sigm2;

n = cols(y); t = rows(y);

       y1 = y[2+s:t-s,.];
       x1 = x[2+s:t-s,.];
       z1 = z[2+s:t-s,.];
       m1 = m[2+s:t-s,.];

       dx = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dz = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dm = zeros(rows(m[2+s:t-s,.]),2*s+1);


  i = 1;
  do while i <= n;

    j = 1;
    do while j <= 2*s+1;
       dx[.,j] = x[2*s+3-j:t+1-j,i] - x[2*s+2-j:t-j,i];
       dz[.,j] = z[2*s+3-j:t+1-j,i] - z[2*s+2-j:t-j,i];
       dm[.,j] = m[2*s+3-j:t+1-j,i] - m[2*s+2-j:t-j,i];
    j = j + 1;
    endo;
    
       y1[.,i] = y[2+s:t-s,i];
       x1[.,i] = x[2+s:t-s,i];
       z1[.,i] = z[2+s:t-s,i];
       m1[.,i] = m[2+s:t-s,i];

  if icase == 1; xq = dx~dz~dm; endif;
  if icase == 2; xq = ones(rows(dx),1)~dx~dz~dm; endif;
  if icase == 3; xq = ones(rows(dx),1)~seqa(1,1,rows(dx))~dx~dz~dm; endif;

       xq = xq*invpd(xq'xq)*xq';
     y1[.,i] = y1[.,i] - xq*y1[.,i];
     x1[.,i] = x1[.,i] - xq*x1[.,i];
     z1[.,i] = z1[.,i] - xq*z1[.,i];
     m1[.,i] = m1[.,i] - xq*m1[.,i];

  i = i + 1;
  endo;

  bb   = zeros(5,n);
  rrs  = y1;
  bs2  = zeros(5,n);

  i = 1;
  do while i <= n;
    qqs = x1[.,i]~z1[.,i]~m1[.,i];
    bbs = invpd(qqs'qqs)*qqs'y1[.,i];
    rrs[.,i] = y1[.,i] - qqs*bbs;
  i = i + 1;
  endo;

indx = detlag(rrs,p,0);
{sigma} = crox(rrs,indx,p);

sigm1 = abs(sigma);
sigm1 = sigm1 - eye(cols(sigm1));
sigm1 = sumc(sigm1)./(cols(sigm1)-1);

indxc = {};

i = 1;
do while i <= n;
  if sigm1[i] > 0.49; indxc = indxc~i; endif;
i = i + 1;
endo;

if cols(indxc) > 1; 
rrs = rrs[.,indxc];
indx = detlag(rrs,p,0);
{sigm2} = crox(rrs,indx,p);
endif;

format /m1 /rd 4,1;
"";
"";
"";
"";
"";
"";
"";
"";

" __________________ Correlation Matrix for all units_________________";
"";
"";
"     ";;seqa(1,1,cols(y))';
"_____________________________________________________________________";
i = 1;
do while i <= cols(y);
 i;;"|";;sigma[i,.];
i = i + 1;
endo;
"_____________________________________________________________________";
"";
if cols(indxc) < 2;
" No high cross sectional correlation in the data: 
  use common time effects to handle for cross section dependence";
goto mani1;
endif;

if cols(sigm2) > 2; 
" ___________________ Highest Correlation (>= 0.5) units _____________";

"     ";;indxc;
"_____________________________________________________________________";
i = 1;
do while i <= cols(sigm2);
 indxc[i];;"|";;sigm2[i,.];
i = i + 1;
endo;
"_____________________________________________________________________";
"";
endif;
mani1:
retp(indxc);
endp;


proc  csdan2(y,x,z,s,p,icase);
local i,n,j,dx,dz,y1,x1,z1,xq,vy,vx,vz,vv,be,t;
local sq1,sq2,x2,z2,y2,x3,y3,z3,www,rr,skk,sk1,sk2;
local skk1,tr01,skk2,tr02,wx,wy,wz,ww,bw1,tw1,bw2,tw2;
local bb,bs,qqs,bbs,rrs,bs1,bs2,ss1,ss2;
local v2,b2;
local sq3,sq4,x4,y4,z4,x5,y5,z5,sk3,sk4,r2,ww2,tr03,tr04,skk3,skk4;
local m1,w1,q1,dm,dw,dq,vm,vw,vq,m2,w2,q2;
local indx,para,ome,res1,sigma;
local sigm1,indxc,sigm2;

n = cols(y); t = rows(y);

       y1 = y[2+s:t-s,.];
       x1 = x[2+s:t-s,.];
       z1 = z[2+s:t-s,.];

       dx = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dz = zeros(rows(x[2+s:t-s,.]),2*s+1);


  i = 1;
  do while i <= n;

    j = 1;
    do while j <= 2*s+1;
       dx[.,j] = x[2*s+3-j:t+1-j,i] - x[2*s+2-j:t-j,i];
       dz[.,j] = z[2*s+3-j:t+1-j,i] - z[2*s+2-j:t-j,i];
    j = j + 1;
    endo;
    
       y1[.,i] = y[2+s:t-s,i];
       x1[.,i] = x[2+s:t-s,i];
       z1[.,i] = z[2+s:t-s,i];

  if icase == 1; xq = dx~dz; endif;
  if icase == 2; xq = ones(rows(dx),1)~dx~dz; endif;
  if icase == 3; xq = ones(rows(dx),1)~seqa(1,1,rows(dx))~dx~dz; endif;

       xq = xq*invpd(xq'xq)*xq';
     y1[.,i] = y1[.,i] - xq*y1[.,i];
     x1[.,i] = x1[.,i] - xq*x1[.,i];
     z1[.,i] = z1[.,i] - xq*z1[.,i];

  i = i + 1;
  endo;

  bb   = zeros(5,n);
  rrs  = y1;
  bs2  = zeros(5,n);

  i = 1;
  do while i <= n;
    qqs = x1[.,i]~z1[.,i];
    bbs = invpd(qqs'qqs)*qqs'y1[.,i];
    rrs[.,i] = y1[.,i] - qqs*bbs;
  i = i + 1;
  endo;

indx = detlag(rrs,p,0);
{sigma} = crox(rrs,indx,p);

sigm1 = abs(sigma);
sigm1 = sigm1 - eye(cols(sigm1));
sigm1 = sumc(sigm1)./(cols(sigm1)-1);

indxc = {};

i = 1;
do while i <= n;
  if sigm1[i] > 0.49; indxc = indxc~i; endif;
i = i + 1;
endo;

if cols(indxc) > 1; 
rrs = rrs[.,indxc];
indx = detlag(rrs,p,0);
{sigm2} = crox(rrs,indx,p);
endif;

format /m1 /rd 4,1;
"";
"";
"";
"";
"";
"";
"";
"";

" __________________ Correlation Matrix for all units_________________";
"";
"";
"     ";;seqa(1,1,cols(y))';
"_____________________________________________________________________";
i = 1;
do while i <= cols(y);
 i;;"|";;sigma[i,.];
i = i + 1;
endo;
"_____________________________________________________________________";
"";
if cols(indxc) < 2;
" No high cross sectional correlation in the data: 
  use common time effects to handle for cross section dependence";
goto mani1;
endif;

if cols(sigm2) > 2; 
" ___________________ Highest Correlation (>= 0.5) units _____________";

"     ";;indxc;
"_____________________________________________________________________";
i = 1;
do while i <= cols(sigm2);
 indxc[i];;"|";;sigm2[i,.];
i = i + 1;
endo;
"_____________________________________________________________________";
"";
endif;
mani1:
retp(indxc);
endp;


proc  csdan1(y,x,s,p,icase);
local i,n,j,dx,dz,y1,x1,z1,xq,vy,vx,vz,vv,be,t;
local sq1,sq2,x2,z2,y2,x3,y3,z3,www,rr,skk,sk1,sk2;
local skk1,tr01,skk2,tr02,wx,wy,wz,ww,bw1,tw1,bw2,tw2;
local bb,bs,qqs,bbs,rrs,bs1,bs2,ss1,ss2;
local v2,b2;
local sq3,sq4,x4,y4,z4,x5,y5,z5,sk3,sk4,r2,ww2,tr03,tr04,skk3,skk4;
local m1,w1,q1,dm,dw,dq,vm,vw,vq,m2,w2,q2;
local indx,para,ome,res1,sigma;
local sigm1,indxc,sigm2;

n = cols(y); t = rows(y);

       y1 = y[2+s:t-s,.];
       x1 = x[2+s:t-s,.];

       dx = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dz = zeros(rows(x[2+s:t-s,.]),2*s+1);

  i = 1;
  do while i <= n;

    j = 1;
    do while j <= 2*s+1;
       dx[.,j] = x[2*s+3-j:t+1-j,i] - x[2*s+2-j:t-j,i];
    j = j + 1;
    endo;
    
       y1[.,i] = y[2+s:t-s,i];
       x1[.,i] = x[2+s:t-s,i];

  if icase == 1; xq = dx; endif;
  if icase == 2; xq = ones(rows(dx),1)~dx; endif;
  if icase == 3; xq = ones(rows(dx),1)~seqa(1,1,rows(dx))~dx; endif;

       xq = xq*invpd(xq'xq)*xq';
     y1[.,i] = y1[.,i] - xq*y1[.,i];
     x1[.,i] = x1[.,i] - xq*x1[.,i];

  i = i + 1;
  endo;

  bb   = zeros(5,n);
  rrs  = y1;
  bs2  = zeros(5,n);

  i = 1;
  do while i <= n;
    qqs = x1[.,i];
    bbs = invpd(qqs'qqs)*qqs'y1[.,i];
    rrs[.,i] = y1[.,i] - qqs*bbs;
  i = i + 1;
  endo;

indx = detlag(rrs,p,0);
{sigma} = crox(rrs,indx,p);

sigm1 = abs(sigma);
sigm1 = sigm1 - eye(cols(sigm1));
sigm1 = sumc(sigm1)./(cols(sigm1)-1);

indxc = {};

i = 1;
do while i <= n;
  if sigm1[i] > 0.49; indxc = indxc~i; endif;
i = i + 1;
endo;

if cols(indxc) > 1; 
rrs = rrs[.,indxc];
indx = detlag(rrs,p,0);
{sigm2} = crox(rrs,indx,p);
endif;

format /m1 /rd 4,1;
"";
"";
"";
"";
"";
"";
"";
"";
"";

" __________________ Correlation Matrix for all units_________________";
"";
"";
"     ";;seqa(1,1,cols(y))';
"_____________________________________________________________________";
i = 1;
do while i <= cols(y);
 i;;"|";;sigma[i,.];
i = i + 1;
endo;
"_____________________________________________________________________";
"";
if cols(indxc) < 2;
" No high cross sectional correlation in the data: 
  use common time effects to handle for cross section dependence";
goto mani1;
endif;

if cols(sigm2) > 2; 
" ___________________ Highest Correlation (>= 0.5) units _____________";

"     ";;indxc;
"_____________________________________________________________________";
i = 1;
do while i <= cols(sigm2);
 indxc[i];;"|";;sigm2[i,.];
i = i + 1;
endo;
"_____________________________________________________________________";
"";
endif;
mani1:
retp(indxc);
endp;





proc  dsur5(y,x,z,m,w,q,s,p,icase);
local i,n,j,dx,dz,y1,x1,z1,xq,vy,vx,vz,vv,be,t;
local sq1,sq2,x2,z2,y2,x3,y3,z3,www,rr,skk,sk1,sk2;
local skk1,tr01,skk2,tr02,wx,wy,wz,ww,bw1,tw1,bw2,tw2;
local bb,bs,qqs,bbs,rrs,bs1,bs2,ss1,ss2;
local v2,b2;
local sq3,sq4,x4,y4,z4,x5,y5,z5,sk3,sk4,r2,ww2,tr03,tr04,skk3,skk4;
local m1,w1,q1,dm,dw,dq,vm,vw,vq,m2,w2,q2;
local rr1,rr2,ccc1,rrr,vx2,vy2;
local res,bet;
local indx,para,res1,fff,ome,ome1,kk,kkk,ttl,qkk1,kq,vx3,qkk2;
local bet1,ttl1;
local tbet,ttr,ttet,cric;
local kqq1,kqq2,kqq3,kqq4,kqq5;
local sc1,sc2,sc3,sc4,sc5;
local rk1,rk2,rk3,rk4,rk5,rr0;
local cri0,cri1,cri2,cri3,cri4,cri5;

n = cols(y); t = rows(y);

rr1 = eye(5);

i = 2;
do while i <= n-1;
 rr1 = rr1|eye(5);
i = i + 1;
endo;

rr2 = -eye(5*(n-1));
rr0 =rr1~rr2;

rk1 = zeros(rows(rr0),cols(rr0));
rk2 = rk1;
rk3 = rk1;
rk4 = rk1;
rk5 = rk1;

i = 1;
do while i <= n-1;
 rk1[1+(i-1)*5,.] = rr0[1+(i-1)*5,.];
 rk2[2+(i-1)*5,.] = rr0[2+(i-1)*5,.];
 rk3[3+(i-1)*5,.] = rr0[3+(i-1)*5,.];
 rk4[4+(i-1)*5,.] = rr0[4+(i-1)*5,.];
 rk5[5+(i-1)*5,.] = rr0[5+(i-1)*5,.];
i = i + 1;
endo;
       y1 = y[2+s:t-s,.];
       x1 = x[2+s:t-s,.];
       z1 = z[2+s:t-s,.];
       m1 = m[2+s:t-s,.];
       w1 = w[2+s:t-s,.];
       q1 = q[2+s:t-s,.];

       dx = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dz = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dm = zeros(rows(m[2+s:t-s,.]),2*s+1);
       dw = zeros(rows(w[2+s:t-s,.]),2*s+1);
       dq = zeros(rows(q[2+s:t-s,.]),2*s+1);


  i = 1;
  do while i <= n;

    j = 1;
    do while j <= 2*s+1;
       dx[.,j] = x[2*s+3-j:t+1-j,i] - x[2*s+2-j:t-j,i];
       dz[.,j] = z[2*s+3-j:t+1-j,i] - z[2*s+2-j:t-j,i];
       dm[.,j] = m[2*s+3-j:t+1-j,i] - m[2*s+2-j:t-j,i];
       dw[.,j] = w[2*s+3-j:t+1-j,i] - w[2*s+2-j:t-j,i];
       dq[.,j] = q[2*s+3-j:t+1-j,i] - q[2*s+2-j:t-j,i];
    j = j + 1;
    endo;
    
       y1[.,i] = y[2+s:t-s,i];
       x1[.,i] = x[2+s:t-s,i];
       z1[.,i] = z[2+s:t-s,i];
       m1[.,i] = m[2+s:t-s,i];
       w1[.,i] = w[2+s:t-s,i];
       q1[.,i] = q[2+s:t-s,i];
  i = i + 1;
  endo;

   if icase == 1; xq = dx~dz~dm~dw~dq; endif;
   if icase == 2; xq = ones(rows(dx),1)~dx~dz~dm~dw~dq; endif;
   if icase == 3; xq = ones(rows(dx),1)~seqa(1,1,rows(dx))~dx~dz~dm~dw~dq; endif;


     xq = xq*invpd(xq'xq)*xq';
  
  i = 1;
  do while i <= n;
     y1[.,i] = y1[.,i] - xq*y1[.,i];
     x1[.,i] = x1[.,i] - xq*x1[.,i];
     z1[.,i] = z1[.,i] - xq*z1[.,i];
     m1[.,i] = m1[.,i] - xq*m1[.,i];
     w1[.,i] = w1[.,i] - xq*w1[.,i];
     q1[.,i] = q1[.,i] - xq*q1[.,i];
  i = i + 1;
  endo;

  bb   = zeros(5,n);
  rrs  = y1;
  bs2  = zeros(5,n);

vy2 = vec(y1);
vx2 = zeros(rows(vy2),cols(x1)*5);

  i = 1;
  do while i <= n;
    qqs = x1[.,i]~z1[.,i]~m1[.,i]~w1[.,i]~q1[.,i];
    bbs = invpd(qqs'qqs)*qqs'y1[.,i];
    rrs[.,i] = y1[.,i] - qqs*bbs;
    vx2[1+(i-1)*rows(x1):i*rows(x1),1+(i-1)*5:i*5] = x1[.,i]~z1[.,i]~m1[.,i]~w1[.,i]~q1[.,i];
  i = i + 1;
  endo;

bet = invpd(vx2'vx2)*vx2'vy2;
rrs = vy2 - vx2*bet;
res = y1;

  i = 1;
  do while i <= n;
   res[.,i] = rrs[1+(i-1)*rows(x1):i*rows(x1),1];
  i = i + 1;
  endo;

indx = detlag(res,p,0);
{para,ome,res1} = sur1(res,indx,p);

fff  = eye(cols(x1)) - eye(cols(x1)).*sumc(para');
ome  = inv(fff)*ome*inv(fff');
ome1 = inv(ome);
kk   = ome1.*.eye(rows(x1));
kkk  = inv(vx2'kk*vx2);
bet  = kkk*vx2'kk*vy2;

ttr = sqrt(diag(kkk));

tbet = zeros(5,n);
ttet = zeros(5,n);

i = 1;
do while i <= n;
 tbet[.,i] = (bet[1+(i-1)*5]~bet[2+(i-1)*5]~bet[3+(i-1)*5]~bet[4+(i-1)*5]~bet[5+(i-1)*5])';
 ttet[.,i] = (ttr[1+(i-1)*5]~ttr[2+(i-1)*5]~ttr[3+(i-1)*5]~ttr[4+(i-1)*5]~ttr[5+(i-1)*5])';
i = i + 1;
endo;

kq = rr0*bet;
ccc1 = (rr0*bet)'inv(rr0*kkk*rr0')*(rr0*bet);

@kqq1 = rk1*bet;
kqq2 = rk2*bet;
kqq3 = rk3*bet;
kqq4 = rk4*bet;
kqq5 = rk5*bet;

sc1 = (rk1*bet)'inv(rk1*kkk*rk1')*(rk1*bet);
sc2 = (rk2*bet)'inv(rk2*kkk*rk2')*(rk2*bet);
sc3 = (rk3*bet)'inv(rk3*kkk*rk3')*(rk3*bet);
sc4 = (rk4*bet)'inv(rk4*kkk*rk4')*(rk4*bet);
sc5 = (rk5*bet)'inv(rk5*kkk*rk5')*(rk5*bet);@


cri0 =  cdfchic(ccc1,rows(rr0));
@cri1 = 1 - cdfchic(sc1,n-1);
cri2 = 1 - cdfchic(sc2,n-1);
cri3 = 1 - cdfchic(sc3,n-1);
cri4 = 1 - cdfchic(sc4,n-1);
cri5 = 1 - cdfchic(sc5,n-1);@

vx3 = vec(x1)~vec(z1)~vec(m1)~vec(w1)~vec(q1);
bet = invpd(vx3'vx3)*vx3'vy2;
res = y1 - x1*bet[1] - z1*bet[2] - m1*bet[3] - w1*bet[4] - q1*bet[5];

indx = detlag(res,p,0);

{para,ome,res1} = sur1(res,indx,p);
fff = eye(cols(x)) - eye(cols(x)).*sumc(para');
ome = inv(fff)*ome*inv(fff');
ome1 = invpd(ome);
kk = ome1.*.eye(rows(x1));
kkk = invpd(vx3'kk*vx3);

bet1 = kkk*vx3'kk*vy2;
ttl1 = sqrt(diag(kkk));
qkk2 = bet1~ttl1;
format /m1 /rd 8,4;

format /m1 /rd 4,1;
"";
"";
"";
"";
"";
"";
"";
"";
if icase == 2;
"Model: y(it) = c(i) + A1*x(it) + A2*z(it) + A3*m(it) + A4*w(it)  + A5*q(it) +  u(it) ";
"";
endif;

if icase == 3;
"Model: y(it) = c(i) + d(i)*t + A1*x(it) + A2*z(it) + A3*m(it) + A4*w(it)  + A5*q(it) +  u(it) ";
endif;
"";
"";
"";
"";
" _______________________ ESTIMATION RESULTS __________________________";
"";
"";
"";
format /m1 /rd 7,3;
"__________________ Dynamic SUR for Single Equation ___________________";
"";
"Eq No.     A1     s.e     A2      s.e      A3     s.e      A4      s.e      A5      s.e ";
"_______________________________________________________________________";
i = 1;
do while i <= n;
i~tbet[1,i]~ttet[1,i]~tbet[2,i]~ttet[2,i]~tbet[3,i]~ttet[3,i]~tbet[4,i]~ttet[4,i]~tbet[5,i]~ttet[5,i];
i = i + 1;
endo;
"_______________________________________________________________________";
"";
"";
"_________________________ Homogeneity Test ________________________";

"  Null Hypothesis  Chi-Squared   P-value(% of rejection)";
" All 5 are the same";;"  ";;ccc1;;"  ";;cri0;
"";
"";
if cri0 < 0.05;
" You can reject the null hypothesis of homogeneity at 5% level";
endif;
if cri0 > 0.05;
" You cannot reject the null hypothesis of homogeneity at 5% level";
endif;


@" A1s are the same";;sc1;;cri1;
" A2s are the same";;sc2;;cri2;
" A3s are the same";;sc3;;cri3;
" A4s are the same";;sc4;;cri4;
" A5s are the same";;sc5;;cri4;@
"____________________________ Pooled  SUR ______________________________";
"";
"     PDSUR   S.E.     ";
"            Param    ";
"_______________________________________________________________________";
" A1";;qkk2[1,.];
" A2";;qkk2[2,.];
" A3";;qkk2[3,.];
" A4";;qkk2[4,.];
" A5";;qkk2[5,.];


mani:
retp(qkk2);
endp;


proc  dsur4(y,x,z,m,w,s,p,icase);
local i,n,j,dx,dz,y1,x1,z1,xq,vy,vx,vz,vv,be,t;
local sq1,sq2,x2,z2,y2,x3,y3,z3,www,rr,skk,sk1,sk2;
local skk1,tr01,skk2,tr02,wx,wy,wz,ww,bw1,tw1,bw2,tw2;
local bb,bs,qqs,bbs,rrs,bs1,bs2,ss1,ss2;
local v2,b2;
local sq3,sq4,x4,y4,z4,x5,y5,z5,sk3,sk4,r2,ww2,tr03,tr04,skk3,skk4;
local m1,w1,q1,dm,dw,dq,vm,vw,vq,m2,w2,q2;
local rr1,rr2,ccc1,rrr,vx2,vy2;
local res,bet;
local indx,para,res1,fff,ome,ome1,kk,kkk,ttl,qkk1,kq,vx3,qkk2;
local bet1,ttl1;
local tbet,ttr,ttet,cric;
local kqq1,kqq2,kqq3,kqq4,kqq5;
local sc1,sc2,sc3,sc4,sc5;
local rk1,rk2,rk3,rk4,rk5,rr0;
local cri0,cri1,cri2,cri3,cri4,cri5;

n = cols(y); t = rows(y);

rr1 = eye(4);

i = 2;
do while i <= n-1;
 rr1 = rr1|eye(4);
i = i + 1;
endo;

rr2 = -eye(4*(n-1));
rr0 =rr1~rr2;

rk1 = zeros(rows(rr0),cols(rr0));
rk2 = rk1;
rk3 = rk1;
rk4 = rk1;

       y1 = y[2+s:t-s,.];
       x1 = x[2+s:t-s,.];
       z1 = z[2+s:t-s,.];
       m1 = m[2+s:t-s,.];
       w1 = w[2+s:t-s,.];

       dx = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dz = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dm = zeros(rows(m[2+s:t-s,.]),2*s+1);
       dw = zeros(rows(w[2+s:t-s,.]),2*s+1);


  i = 1;
  do while i <= n;

    j = 1;
    do while j <= 2*s+1;
       dx[.,j] = x[2*s+3-j:t+1-j,i] - x[2*s+2-j:t-j,i];
       dz[.,j] = z[2*s+3-j:t+1-j,i] - z[2*s+2-j:t-j,i];
       dm[.,j] = m[2*s+3-j:t+1-j,i] - m[2*s+2-j:t-j,i];
       dw[.,j] = w[2*s+3-j:t+1-j,i] - w[2*s+2-j:t-j,i];
    j = j + 1;
    endo;
    
       y1[.,i] = y[2+s:t-s,i];
       x1[.,i] = x[2+s:t-s,i];
       z1[.,i] = z[2+s:t-s,i];
       m1[.,i] = m[2+s:t-s,i];
       w1[.,i] = w[2+s:t-s,i];
  i = i + 1;
  endo;

   if icase == 1; xq = dx~dz~dm~dw; endif;
   if icase == 2; xq = ones(rows(dx),1)~dx~dz~dm~dw; endif;
   if icase == 3; xq = ones(rows(dx),1)~seqa(1,1,rows(dx))~dx~dz~dm~dw; endif;


     xq = xq*invpd(xq'xq)*xq';
  
  i = 1;
  do while i <= n;
     y1[.,i] = y1[.,i] - xq*y1[.,i];
     x1[.,i] = x1[.,i] - xq*x1[.,i];
     z1[.,i] = z1[.,i] - xq*z1[.,i];
     m1[.,i] = m1[.,i] - xq*m1[.,i];
     w1[.,i] = w1[.,i] - xq*w1[.,i];
  i = i + 1;
  endo;

  bb   = zeros(4,n);
  rrs  = y1;
  bs2  = zeros(4,n);

vy2 = vec(y1);
vx2 = zeros(rows(vy2),cols(x1)*4);

  i = 1;
  do while i <= n;
    qqs = x1[.,i]~z1[.,i]~m1[.,i]~w1[.,i];
    bbs = invpd(qqs'qqs)*qqs'y1[.,i];
    rrs[.,i] = y1[.,i] - qqs*bbs;
    vx2[1+(i-1)*rows(x1):i*rows(x1),1+(i-1)*4:i*4] = x1[.,i]~z1[.,i]~m1[.,i]~w1[.,i];
  i = i + 1;
  endo;

bet = invpd(vx2'vx2)*vx2'vy2;
rrs = vy2 - vx2*bet;
res = y1;

  i = 1;
  do while i <= n;
   res[.,i] = rrs[1+(i-1)*rows(x1):i*rows(x1),1];
  i = i + 1;
  endo;

indx = detlag(res,p,0);
{para,ome,res1} = sur1(res,indx,p);

fff  = eye(cols(x1)) - eye(cols(x1)).*sumc(para');
ome  = inv(fff)*ome*inv(fff');
ome1 = inv(ome);
kk   = ome1.*.eye(rows(x1));
kkk  = inv(vx2'kk*vx2);
bet  = kkk*vx2'kk*vy2;

ttr = sqrt(diag(kkk));

tbet = zeros(4,n);
ttet = zeros(4,n);

i = 1;
do while i <= n;
 tbet[.,i] = (bet[1+(i-1)*4]~bet[2+(i-1)*4]~bet[3+(i-1)*4]~bet[4+(i-1)*4])';
 ttet[.,i] = (ttr[1+(i-1)*4]~ttr[2+(i-1)*4]~ttr[3+(i-1)*4]~ttr[4+(i-1)*4])';
i = i + 1;
endo;

kq = rr0*bet;
ccc1 = (rr0*bet)'inv(rr0*kkk*rr0')*(rr0*bet);

cri0 =  cdfchic(ccc1,rows(rr0));

vx3 = vec(x1)~vec(z1)~vec(m1)~vec(w1);
bet = invpd(vx3'vx3)*vx3'vy2;
res = y1 - x1*bet[1] - z1*bet[2] - m1*bet[3] - w1*bet[4];

indx = detlag(res,p,0);

{para,ome,res1} = sur1(res,indx,p);
fff = eye(cols(x)) - eye(cols(x)).*sumc(para');
ome = inv(fff)*ome*inv(fff');
ome1 = invpd(ome);
kk = ome1.*.eye(rows(x1));
kkk = invpd(vx3'kk*vx3);

bet1 = kkk*vx3'kk*vy2;
ttl1 = sqrt(diag(kkk));
qkk2 = bet1~ttl1;
format /m1 /rd 8,4;

format /m1 /rd 4,1;
"";
"";
"";
"";
"";
"";
"";
"";
if icase == 2;
"Model: y(it) = c(i) + A1*x(it) + A2*z(it) + A3*m(it) + A4*w(it)  +  u(it) ";
"";
endif;

if icase == 3;
"Model: y(it) = c(i) + d(i)*t + A1*x(it) + A2*z(it) + A3*m(it) + A4*w(it)  +  u(it) ";
endif;
"";
"";
"";
"";
" _______________________ ESTIMATION RESULTS __________________________";
"";
"";
"";
format /m1 /rd 7,3;
"__________________ Dynamic SUR for Single Equation ___________________";
"";
"Eq No.     A1     s.e     A2      s.e      A3     s.e      A4      s.e   ";
"_______________________________________________________________________";
i = 1;
do while i <= n;
i~tbet[1,i]~ttet[1,i]~tbet[2,i]~ttet[2,i]~tbet[3,i]~ttet[3,i]~tbet[4,i]~ttet[4,i];
i = i + 1;
endo;
"_______________________________________________________________________";
"";
"";
"_________________________ Homogeneity Test ________________________";

"  Null Hypothesis  Chi-Squared   P-value(% of rejection)";
" All 4 are the same";;"  ";;ccc1;;"  ";;cri0;
"";
"";
if cri0 < 0.05;
" You can reject the null hypothesis of homogeneity at 5% level";
endif;
if cri0 > 0.05;
" You cannot reject the null hypothesis of homogeneity at 5% level";
endif;


@" A1s are the same";;sc1;;cri1;
" A2s are the same";;sc2;;cri2;
" A3s are the same";;sc3;;cri3;
" A4s are the same";;sc4;;cri4;
" A5s are the same";;sc5;;cri4;@
"____________________________ Pooled  SUR ______________________________";
"";
"     PDSUR   S.E.     ";
"            Param    ";
"_______________________________________________________________________";
" A1";;qkk2[1,.];
" A2";;qkk2[2,.];
" A3";;qkk2[3,.];
" A4";;qkk2[4,.];



mani:
retp(qkk2);
endp;

proc  dsur3(y,x,z,m,s,p,icase);
local i,n,j,dx,dz,y1,x1,z1,xq,vy,vx,vz,vv,be,t;
local sq1,sq2,x2,z2,y2,x3,y3,z3,www,rr,skk,sk1,sk2;
local skk1,tr01,skk2,tr02,wx,wy,wz,ww,bw1,tw1,bw2,tw2;
local bb,bs,qqs,bbs,rrs,bs1,bs2,ss1,ss2;
local v2,b2;
local sq3,sq4,x4,y4,z4,x5,y5,z5,sk3,sk4,r2,ww2,tr03,tr04,skk3,skk4;
local m1,w1,q1,dm,dw,dq,vm,vw,vq,m2,w2,q2;
local rr1,rr2,ccc1,rrr,vx2,vy2;
local res,bet;
local indx,para,res1,fff,ome,ome1,kk,kkk,ttl,qkk1,kq,vx3,qkk2;
local bet1,ttl1;
local tbet,ttr,ttet,cric;
local kqq1,kqq2,kqq3,kqq4,kqq5;
local sc1,sc2,sc3,sc4,sc5;
local rk1,rk2,rk3,rk4,rk5,rr0;
local cri0,cri1,cri2,cri3,cri4,cri5;

n = cols(y); t = rows(y);

rr1 = eye(3);

i = 2;
do while i <= n-1;
 rr1 = rr1|eye(3);
i = i + 1;
endo;

rr2 = -eye(3*(n-1));
rr0 =rr1~rr2;

rk1 = zeros(rows(rr0),cols(rr0));
rk2 = rk1;
rk3 = rk1;

       y1 = y[2+s:t-s,.];
       x1 = x[2+s:t-s,.];
       z1 = z[2+s:t-s,.];
       m1 = m[2+s:t-s,.];

       dx = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dz = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dm = zeros(rows(m[2+s:t-s,.]),2*s+1);


  i = 1;
  do while i <= n;

    j = 1;
    do while j <= 2*s+1;
       dx[.,j] = x[2*s+3-j:t+1-j,i] - x[2*s+2-j:t-j,i];
       dz[.,j] = z[2*s+3-j:t+1-j,i] - z[2*s+2-j:t-j,i];
       dm[.,j] = m[2*s+3-j:t+1-j,i] - m[2*s+2-j:t-j,i];
    j = j + 1;
    endo;
    
       y1[.,i] = y[2+s:t-s,i];
       x1[.,i] = x[2+s:t-s,i];
       z1[.,i] = z[2+s:t-s,i];
       m1[.,i] = m[2+s:t-s,i];
  i = i + 1;
  endo;

   if icase == 1; xq = dx~dz~dm; endif;
   if icase == 2; xq = ones(rows(dx),1)~dx~dz~dm; endif;
   if icase == 3; xq = ones(rows(dx),1)~seqa(1,1,rows(dx))~dx~dz~dm; endif;
     xq = xq*invpd(xq'xq)*xq';
  
  i = 1;
  do while i <= n;
     y1[.,i] = y1[.,i] - xq*y1[.,i];
     x1[.,i] = x1[.,i] - xq*x1[.,i];
     z1[.,i] = z1[.,i] - xq*z1[.,i];
     m1[.,i] = m1[.,i] - xq*m1[.,i];
  i = i + 1;
  endo;

  bb   = zeros(3,n);
  rrs  = y1;
  bs2  = zeros(3,n);

vy2 = vec(y1);
vx2 = zeros(rows(vy2),cols(x1)*3);

  i = 1;
  do while i <= n;
    qqs = x1[.,i]~z1[.,i]~m1[.,i];
    bbs = invpd(qqs'qqs)*qqs'y1[.,i];
    rrs[.,i] = y1[.,i] - qqs*bbs;
    vx2[1+(i-1)*rows(x1):i*rows(x1),1+(i-1)*3:i*3] = x1[.,i]~z1[.,i]~m1[.,i];
  i = i + 1;
  endo;

bet = invpd(vx2'vx2)*vx2'vy2;
rrs = vy2 - vx2*bet;
res = y1;

  i = 1;
  do while i <= n;
   res[.,i] = rrs[1+(i-1)*rows(x1):i*rows(x1),1];
  i = i + 1;
  endo;

indx = detlag(res,p,0);
{para,ome,res1} = sur1(res,indx,p);

fff  = eye(cols(x1)) - eye(cols(x1)).*sumc(para');
ome  = inv(fff)*ome*inv(fff');
ome1 = inv(ome);
kk   = ome1.*.eye(rows(x1));
kkk  = inv(vx2'kk*vx2);
bet  = kkk*vx2'kk*vy2;

ttr = sqrt(diag(kkk));

tbet = zeros(3,n);
ttet = zeros(3,n);

i = 1;
do while i <= n;
 tbet[.,i] = (bet[1+(i-1)*3]~bet[2+(i-1)*3]~bet[3+(i-1)*3])';
 ttet[.,i] = (ttr[1+(i-1)*3]~ttr[2+(i-1)*3]~ttr[3+(i-1)*3])';
i = i + 1;
endo;

kq = rr0*bet;
ccc1 = (rr0*bet)'inv(rr0*kkk*rr0')*(rr0*bet);

cri0 =  cdfchic(ccc1,rows(rr0));

vx3 = vec(x1)~vec(z1)~vec(m1);
bet = invpd(vx3'vx3)*vx3'vy2;
res = y1 - x1*bet[1] - z1*bet[2] - m1*bet[3];

indx = detlag(res,p,0);

{para,ome,res1} = sur1(res,indx,p);
fff = eye(cols(x)) - eye(cols(x)).*sumc(para');
ome = inv(fff)*ome*inv(fff');
ome1 = invpd(ome);
kk = ome1.*.eye(rows(x1));
kkk = invpd(vx3'kk*vx3);

bet1 = kkk*vx3'kk*vy2;
ttl1 = sqrt(diag(kkk));
qkk2 = bet1~ttl1;
format /m1 /rd 8,4;

format /m1 /rd 4,1;
"";
"";
"";
"";
"";
"";
"";
"";
if icase == 2;
"Model: y(it) = c(i) + A1*x(it) + A2*z(it) + A3*m(it)  +  u(it) ";
"";
endif;

if icase == 3;
"Model: y(it) = c(i) + d(i)*t + A1*x(it) + A2*z(it) + A3*m(it)  +  u(it) ";
endif;
"";
"";
"";
"";
" _______________________ ESTIMATION RESULTS __________________________";
"";
"";
"";
format /m1 /rd 7,3;
"__________________ Dynamic SUR for Single Equation ___________________";
"";
"Eq No.     A1     s.e     A2      s.e      A3     s.e   ";
"_______________________________________________________________________";
i = 1;
do while i <= n;
i~tbet[1,i]~ttet[1,i]~tbet[2,i]~ttet[2,i]~tbet[3,i]~ttet[3,i];
i = i + 1;
endo;
"_______________________________________________________________________";
"";
"";
"_________________________ Homogeneity Test ________________________";

"  Null Hypothesis  Chi-Squared   P-value(% of rejection)";
" All 3 are the same";;"  ";;ccc1;;"  ";;cri0;
"";
"";
if cri0 < 0.05;
" You can reject the null hypothesis of homogeneity at 5% level";
endif;
if cri0 > 0.05;
" You cannot reject the null hypothesis of homogeneity at 5% level";
endif;


"____________________________ Pooled  SUR ______________________________";
"";
"     PDSUR   S.E.     ";
"            Param    ";
"_______________________________________________________________________";
" A1";;qkk2[1,.];
" A2";;qkk2[2,.];
" A3";;qkk2[3,.];

mani:
retp(qkk2);
endp;

proc  dsur2(y,x,z,s,p,icase);
local i,n,j,dx,dz,y1,x1,z1,xq,vy,vx,vz,vv,be,t;
local sq1,sq2,x2,z2,y2,x3,y3,z3,www,rr,skk,sk1,sk2;
local skk1,tr01,skk2,tr02,wx,wy,wz,ww,bw1,tw1,bw2,tw2;
local bb,bs,qqs,bbs,rrs,bs1,bs2,ss1,ss2;
local v2,b2;
local sq3,sq4,x4,y4,z4,x5,y5,z5,sk3,sk4,r2,ww2,tr03,tr04,skk3,skk4;
local m1,w1,q1,dm,dw,dq,vm,vw,vq,m2,w2,q2;
local rr1,rr2,ccc1,rrr,vx2,vy2;
local res,bet;
local indx,para,res1,fff,ome,ome1,kk,kkk,ttl,qkk1,kq,vx3,qkk2;
local bet1,ttl1;
local tbet,ttr,ttet,cric;
local kqq1,kqq2,kqq3,kqq4,kqq5;
local sc1,sc2,sc3,sc4,sc5;
local rk1,rk2,rk3,rk4,rk5,rr0;
local cri0,cri1,cri2,cri3,cri4,cri5;

n = cols(y); t = rows(y);

rr1 = eye(2);

i = 2;
do while i <= n-1;
 rr1 = rr1|eye(2);
i = i + 1;
endo;

rr2 = -eye(2*(n-1));
rr0 =rr1~rr2;

rk1 = zeros(rows(rr0),cols(rr0));
rk2 = rk1;
rk3 = rk1;

       y1 = y[2+s:t-s,.];
       x1 = x[2+s:t-s,.];
       z1 = z[2+s:t-s,.];

       dx = zeros(rows(x[2+s:t-s,.]),2*s+1);
       dz = zeros(rows(x[2+s:t-s,.]),2*s+1);


  i = 1;
  do while i <= n;

    j = 1;
    do while j <= 2*s+1;
       dx[.,j] = x[2*s+3-j:t+1-j,i] - x[2*s+2-j:t-j,i];
       dz[.,j] = z[2*s+3-j:t+1-j,i] - z[2*s+2-j:t-j,i];
    j = j + 1;
    endo;
    
       y1[.,i] = y[2+s:t-s,i];
       x1[.,i] = x[2+s:t-s,i];
       z1[.,i] = z[2+s:t-s,i];
  i = i + 1;
  endo;

   if icase == 1; xq = dx~dz; endif;
   if icase == 2; xq = ones(rows(dx),1)~dx~dz; endif;
   if icase == 3; xq = ones(rows(dx),1)~seqa(1,1,rows(dx))~dx~dz; endif;

     xq = xq*invpd(xq'xq)*xq';
  
  i = 1;
  do while i <= n;
     y1[.,i] = y1[.,i] - xq*y1[.,i];
     x1[.,i] = x1[.,i] - xq*x1[.,i];
     z1[.,i] = z1[.,i] - xq*z1[.,i];
  i = i + 1;
  endo;

  bb   = zeros(2,n);
  rrs  = y1;
  bs2  = zeros(2,n);

vy2 = vec(y1);
vx2 = zeros(rows(vy2),cols(x1)*2);

  i = 1;
  do while i <= n;
    qqs = x1[.,i]~z1[.,i];
    bbs = invpd(qqs'qqs)*qqs'y1[.,i];
    rrs[.,i] = y1[.,i] - qqs*bbs;
    vx2[1+(i-1)*rows(x1):i*rows(x1),1+(i-1)*2:i*2] = x1[.,i]~z1[.,i];
  i = i + 1;
  endo;

bet = invpd(vx2'vx2)*vx2'vy2;
rrs = vy2 - vx2*bet;
res = y1;

  i = 1;
  do while i <= n;
   res[.,i] = rrs[1+(i-1)*rows(x1):i*rows(x1),1];
  i = i + 1;
  endo;

indx = detlag(res,p,0);
{para,ome,res1} = sur1(res,indx,p);

fff  = eye(cols(x1)) - eye(cols(x1)).*sumc(para');
ome  = inv(fff)*ome*inv(fff');
ome1 = inv(ome);
kk   = ome1.*.eye(rows(x1));
kkk  = inv(vx2'kk*vx2);
bet  = kkk*vx2'kk*vy2;

ttr = sqrt(diag(kkk));

tbet = zeros(2,n);
ttet = zeros(2,n);

i = 1;
do while i <= n;
 tbet[.,i] = (bet[1+(i-1)*2]~bet[2+(i-1)*2])';
 ttet[.,i] = (ttr[1+(i-1)*2]~ttr[2+(i-1)*2])';
i = i + 1;
endo;

kq = rr0*bet;
ccc1 = (rr0*bet)'inv(rr0*kkk*rr0')*(rr0*bet);

cri0 =  cdfchic(ccc1,rows(rr0));

vx3 = vec(x1)~vec(z1);
bet = invpd(vx3'vx3)*vx3'vy2;
res = y1 - x1*bet[1] - z1*bet[2];

indx = detlag(res,p,0);

{para,ome,res1} = sur1(res,indx,p);
fff = eye(cols(x)) - eye(cols(x)).*sumc(para');
ome = inv(fff)*ome*inv(fff');
ome1 = invpd(ome);
kk = ome1.*.eye(rows(x1));
kkk = invpd(vx3'kk*vx3);

bet1 = kkk*vx3'kk*vy2;
ttl1 = sqrt(diag(kkk));
qkk2 = bet1~ttl1;
format /m1 /rd 8,4;

format /m1 /rd 4,1;
"";
"";
"";
"";
"";
"";
"";
"";
if icase == 2;
"Model: y(it) = c(i) + A1*x(it) + A2*z(it)  +  u(it) ";
"";
endif;

if icase == 3;
"Model: y(it) = c(i) + d(i)*t + A1*x(it) + A2*z(it)  +  u(it) ";
endif;
"";
"";
"";
"";
" _______________________ ESTIMATION RESULTS __________________________";
"";
"";
"";
format /m1 /rd 7,3;
"__________________ Dynamic SUR for Single Equation ___________________";
"";
"Eq No.     A1     s.e     A2      s.e    ";
"_______________________________________________________________________";
i = 1;
do while i <= n;
i~tbet[1,i]~ttet[1,i]~tbet[2,i]~ttet[2,i];
i = i + 1;
endo;
"_______________________________________________________________________";
"";
"";
"_________________________ Homogeneity Test ________________________";

"  Null Hypothesis  Chi-Squared   P-value(% of rejection)";
" All 3 are the same";;"  ";;ccc1;;"  ";;cri0;
"";
"";
if cri0 < 0.05;
" You can reject the null hypothesis of homogeneity at 5% level";
endif;
if cri0 > 0.05;
" You cannot reject the null hypothesis of homogeneity at 5% level";
endif;


"____________________________ Pooled  SUR ______________________________";
"";
"     PDSUR   S.E.     ";
"            Param    ";
"_______________________________________________________________________";
" A1";;qkk2[1,.];
" A2";;qkk2[2,.];



mani:
retp(qkk2);
endp;


proc  dsur1(y,x,s,p,icase);
local i,n,j,dx,dz,y1,x1,z1,xq,vy,vx,vz,vv,be,t;
local sq1,sq2,x2,z2,y2,x3,y3,z3,www,rr,skk,sk1,sk2;
local skk1,tr01,skk2,tr02,wx,wy,wz,ww,bw1,tw1,bw2,tw2;
local bb,bs,qqs,bbs,rrs,bs1,bs2,ss1,ss2;
local v2,b2;
local sq3,sq4,x4,y4,z4,x5,y5,z5,sk3,sk4,r2,ww2,tr03,tr04,skk3,skk4;
local m1,w1,q1,dm,dw,dq,vm,vw,vq,m2,w2,q2;
local rr1,rr2,ccc1,rrr,vx2,vy2;
local res,bet;
local indx,para,res1,fff,ome,ome1,kk,kkk,ttl,qkk1,kq,vx3,qkk2;
local bet1,ttl1;
local tbet,ttr,ttet,cric;
local kqq1,kqq2,kqq3,kqq4,kqq5;
local sc1,sc2,sc3,sc4,sc5;
local rk1,rk2,rk3,rk4,rk5,rr0;
local cri0,cri1,cri2,cri3,cri4,cri5;

n = cols(y); t = rows(y);

rr1 = eye(1);

i = 2;
do while i <= n-1;
 rr1 = rr1|eye(1);
i = i + 1;
endo;

rr2 = -eye((n-1));
rr0 =rr1~rr2;

rk1 = zeros(rows(rr0),cols(rr0));
rk2 = rk1;
rk3 = rk1;

       y1 = y[2+s:t-s,.];
       x1 = x[2+s:t-s,.];

       dx = zeros(rows(x[2+s:t-s,.]),2*s+1);


  i = 1;
  do while i <= n;

    j = 1;
    do while j <= 2*s+1;
       dx[.,j] = x[2*s+3-j:t+1-j,i] - x[2*s+2-j:t-j,i];
    j = j + 1;
    endo;
    
       y1[.,i] = y[2+s:t-s,i];
       x1[.,i] = x[2+s:t-s,i];
  i = i + 1;
  endo;

   if icase == 1; xq = dx; endif;
   if icase == 2; xq = ones(rows(dx),1)~dx; endif;
   if icase == 3; xq = ones(rows(dx),1)~seqa(1,1,rows(dx))~dx; endif;

     xq = xq*invpd(xq'xq)*xq';
  
  i = 1;
  do while i <= n;
     y1[.,i] = y1[.,i] - xq*y1[.,i];
     x1[.,i] = x1[.,i] - xq*x1[.,i];
  i = i + 1;
  endo;

  bb   = zeros(1,n);
  rrs  = y1;
  bs2  = zeros(1,n);

vy2 = vec(y1);
vx2 = zeros(rows(vy2),cols(x1));

  i = 1;
  do while i <= n;
    qqs = x1[.,i];
    bbs = invpd(qqs'qqs)*qqs'y1[.,i];
    rrs[.,i] = y1[.,i] - qqs*bbs;
    vx2[1+(i-1)*rows(x1):i*rows(x1),1+(i-1):i] = x1[.,i];
  i = i + 1;
  endo;

bet = invpd(vx2'vx2)*vx2'vy2;
rrs = vy2 - vx2*bet;
res = y1;

  i = 1;
  do while i <= n;
   res[.,i] = rrs[1+(i-1)*rows(x1):i*rows(x1),1];
  i = i + 1;
  endo;

indx = detlag(res,p,0);
{para,ome,res1} = sur1(res,indx,p);

fff  = eye(cols(x1)) - eye(cols(x1)).*sumc(para');
ome  = inv(fff)*ome*inv(fff');
ome1 = inv(ome);
kk   = ome1.*.eye(rows(x1));
kkk  = inv(vx2'kk*vx2);
bet  = kkk*vx2'kk*vy2;

ttr = sqrt(diag(kkk));

tbet = zeros(1,n);
ttet = zeros(1,n);

i = 1;
do while i <= n;
 tbet[.,i] = (bet[i])';
 ttet[.,i] = (ttr[i])';
i = i + 1;
endo;

kq = rr0*bet;
ccc1 = (rr0*bet)'inv(rr0*kkk*rr0')*(rr0*bet);

cri0 =  cdfchic(ccc1,rows(rr0));

vx3 = vec(x1);
bet = invpd(vx3'vx3)*vx3'vy2;
res = y1 - x1*bet[1] ;

indx = detlag(res,p,0);

{para,ome,res1} = sur1(res,indx,p);
fff = eye(cols(x)) - eye(cols(x)).*sumc(para');
ome = inv(fff)*ome*inv(fff');
ome1 = invpd(ome);
kk = ome1.*.eye(rows(x1));
kkk = invpd(vx3'kk*vx3);

bet1 = kkk*vx3'kk*vy2;
ttl1 = sqrt(diag(kkk));
qkk2 = bet1~ttl1;
format /m1 /rd 8,4;

format /m1 /rd 4,1;
"";
"";
"";
"";
"";
"";
"";
"";
if icase == 2;
"Model: y(it) = c(i) + A1*x(it) +  u(it) ";
"";
endif;

if icase == 3;
"Model: y(it) = c(i) + d(i)*t + A1*x(it)  +  u(it) ";
endif;
"";
"";
"";
"";
" _______________________ ESTIMATION RESULTS __________________________";
"";
"";
"";
format /m1 /rd 7,3;
"__________________ Dynamic SUR for Single Equation ___________________";
"";
"Eq No.     A1     s.e   ";
"_______________________________________________________________________";
i = 1;
do while i <= n;
i~tbet[1,i]~ttet[1,i];
i = i + 1;
endo;
"_______________________________________________________________________";
"";
"";
"_________________________ Homogeneity Test ________________________";

"  Null Hypothesis  Chi-Squared   P-value(% of rejection)";
" All 3 are the same";;"  ";;ccc1;;"  ";;cri0;
"";
"";
if cri0 < 0.05;
" You can reject the null hypothesis of homogeneity at 5% level";
endif;
if cri0 > 0.05;
" You cannot reject the null hypothesis of homogeneity at 5% level";
endif;


"____________________________ Pooled  SUR ______________________________";
"";
"     PDSUR   S.E.     ";
"            Param    ";
"_______________________________________________________________________";
" A1";;qkk2[1,.];




mani:
retp(qkk2);
endp;



proc (3) = sur1(x,indx,p);

local t, m, dep,z, i, j, b, e, y, b1, sigma, invsig;
local num, den, indx1, indx2, indx3, indx4, i1, y2, x2, x1,parat;
local oldsig, k, bg, dis, para, k1, cr, oldbg,ik,ix,YZ,XZ,YS,XS,xx,xf;
local mi,kmax,tk,kmax1,indxq,lte;
k1 = 850;  @ maximum number of iteration in iterative SUR @
cr = 0.001; @ convergence criterion in iterative SUR @


mi = indx ;

tk = sumc(mi);
kmax = maxc(mi);
kmax1 = maxc(indx);

{yz, xz} = lagpp(x[.,1],kmax1);
t = rows(xz);
m = cols(x);
e = zeros(t,m);
lte = seqa(1,1,rows(xz));

        {yz, xz} = lagpp(x[.,1],kmax1);
              xz = xz[.,1:indx[1]];
               z = xz;
               b = invpd(z'z)*z'yz;
          e[.,1] = yz - z*b;
               y = yz;
              xx = z;


  i = 2;
  do while i <= m;
        {yz, xz} = lagpp(x[.,i],kmax1);
              xz = xz[.,1:indx[i]];
              z = xz;
             b1 = invpd(z'z)*z'yz;
         e[.,i] = yz - z*b1;
              y = y|yz;
             xx = xx~z;
   i = i + 1;
   endo;


sigma = zeros(m,m);

i = 1;
 do while i <= m;
   sigma[i,i] = e[.,i]'e[.,i]/(rows(z) - 1);
   j = i + 1;
   do while j <= m;
      sigma[i,j] = e[.,i]'e[.,j]/(rows(z) - 1);
      sigma[j,i] = sigma[i,j];
      j = j + 1;
   endo;
   i = i + 1;
endo;

invsig = invpd(sigma);

num = zeros(tk,1);
den = zeros(tk,tk);

indx1 = 0; indx2 = 0;
indx3 = 0; indx4 = 0;

i = 1;
 do while i <= m;

   indx1 = 1 + indx2;
   indx2 = indx1 + mi[i]-1;

   x1 = xx[.,indx1:indx2];
   den[indx1:indx2,indx1:indx2] = x1'x1*invsig[i,i];

indx3 = 0; indx4 = 0;

   j = i + 1;
   do while j <= m;
        if j == i+1; indx3 = sumc(mi[1:j-1,.]) + 1; endif;
        if j >  i+1; indx3 = 1 + indx4; endif;
                     indx4 = indx3 + mi[j]-1;
      x2 = xx[.,indx3:indx4];
      den[indx1:indx2,indx3:indx4] = x1'x2*invsig[i,j];
      den[indx3:indx4,indx1:indx2] = x2'x1*invsig[j,i];
    j = j + 1;
    endo;

 i1 = 1;
   do while i1 <= m;
      y2 = y[(i1-1)*t+1:i1*t];
      num[indx1:indx2,.] = num[indx1:indx2,.] + x1'y2*invsig[i,i1];
      i1 = i1 + 1;
  endo;

  i = i + 1;
endo;

oldbg = invpd(den)*num;

e = zeros(t,m);

indx1 = 0; indx2 = 0; indx3 = 0; indx4 = 0;

i = 1;
 do while i <= m;
                indx1 = (i-1)*t;
                indx2 = 1 + indx3;
                indx3 = indx2 + mi[i]-1;
           e[.,i] =   y[indx1+1:indx1+t]
                   - xx[.,indx2:indx3]*oldbg[indx2:indx3,.];
   i = i + 1;
endo;

oldsig = zeros(m,m);

i = 1;
 do while i <= m;
   oldsig[i,i] = e[.,i]'e[.,i]/(rows(z)-1);
   j = i + 1;
   do while j <= m;
      oldsig[i,j] = e[.,i]'e[.,j]/(rows(e)-1);
      oldsig[j,i] = oldsig[i,j];
      j = j + 1;
   endo;
   i = i + 1;
endo;


ik = 1;
 do while ik <= k1;
   invsig = inv(oldsig);

num = zeros(tk,1);
den = zeros(tk,tk);

indx1 = 0; indx2 = 0;

i = 1;
 do while i <= m;
                indx1 = 1 + indx2;
                indx2 = indx1 + mi[i]-1;
   x1 = xx[.,indx1:indx2];
   den[indx1:indx2,indx1:indx2] = x1'x1*invsig[i,i];

indx3 = 0; indx4 = 0;

   j = i + 1;
   do while j <= m;
        if j == i+1; indx3 = sumc(mi[1:j-1,.]) + 1; endif;
        if j >  i+1; indx3 = 1 + indx4; endif;
                     indx4 = indx3 + mi[j]-1;
      x2 = xx[.,indx3:indx4];
      den[indx1:indx2,indx3:indx4] = x1'x2*invsig[i,j];
      den[indx3:indx4,indx1:indx2] = x2'x1*invsig[j,i];

      j = j + 1;
 endo;

  i1 = 1;
    do while i1 <= m;
         y2 = y[(i1-1)*t+1:i1*t];
         num[indx1:indx2,.] = num[indx1:indx2,.] + x1'y2*invsig[i,i1];
         i1 = i1 + 1;
  endo;

 i = i + 1;
 endo;

   bg = inv(den)*num;
   e = zeros(t,m);

indx1 = 0; indx2 = 0; indx3 = 0;

i = 1;
 do while i <= m;
                indx1 = (i-1)*t;
                indx2 = 1 + indx3;
                indx3 = indx2 + mi[i]-1;
           e[.,i] =   y[indx1+1:indx1+t]
                   - xx[.,indx2:indx3]*bg[indx2:indx3,.];

   i = i + 1;
endo;

   sigma = zeros(m,m);

   i = 1;
   do while i <= m;
      sigma[i,i] = e[.,i]'e[.,i]/(rows(e)-cols(z));

      j = i + 1;
      do while j <= m;
         sigma[i,j] = e[.,i]'e[.,j]/(rows(e)-cols(z));
         sigma[j,i] = sigma[i,j];
         j = j + 1;
      endo;

      i = i + 1;
   endo;

   dis = abs((bg|vec(sigma))-(oldbg|vec(oldsig)))./(oldbg|vec(oldsig));
   dis = maxc(dis);
   if dis < cr; "Round:";;ik;;dis; goto label; endif;
   oldbg = bg; oldsig = sigma;
   ik = ik + 1;
   endo;

label:
para = zeros(m,p);
indx1 = 0; indx2 = 0; indx3 = 0; indx4 = 0;

  i = 1;
  do while i <= m;
                indx1 = 1 + indx2;
                indx2 = indx1 + mi[i]-1;
     para[i,1:rows(bg[indx1:indx2,.])]= (bg[indx1:indx2,.])';
  i = i + 1;
  endo;

retp(para, sigma , e);
endp;


proc (1) = crox(x,indx,p);

local t, m, dep,z, i, j, b, e, y, b1, sigma, invsig;
local num, den, indx1, indx2, indx3, indx4, i1, y2, x2, x1,parat;
local oldsig, k, bg, dis, para, k1, cr, oldbg,ik,ix,YZ,XZ,YS,XS,xx,xf;
local mi,kmax,tk,kmax1,indxq,lte;
k1 = 850;  @ maximum number of iteration in iterative SUR @
cr = 0.001; @ convergence criterion in iterative SUR @


mi = indx ;

tk = sumc(mi);
kmax = maxc(mi);
kmax1 = maxc(indx);

{yz, xz} = lagpp(x[.,1],kmax1);
t = rows(xz);
m = cols(x);
e = zeros(t,m);
lte = seqa(1,1,rows(xz));

        {yz, xz} = lagpp(x[.,1],kmax1);
              xz = xz[.,1:indx[1]];
               z = xz;
               b = invpd(z'z)*z'yz;
          e[.,1] = yz - z*b;
               y = yz;
              xx = z;


  i = 2;
  do while i <= m;
        {yz, xz} = lagpp(x[.,i],kmax1);
              xz = xz[.,1:indx[i]];
              z = xz;
             b1 = invpd(z'z)*z'yz;
         e[.,i] = yz - z*b1;
              y = y|yz;
             xx = xx~z;
   i = i + 1;
   endo;

sigma = corrx(e);
retp(sigma);
endp;




/* =========================================================================
             Programed by Donggyu Sul (d.sul@auckland.ac.nz)
                             Oct. 1998
  ===========================================================================
*/

@ Usage of the Procedures
 (1) Campbell and Perron Rule: Determination of lag length:
     The method: (i) select the maximum order of lag length
                 (ii) if the t value of the coefficient on the final lagged
                      variable < 1.96 => drop the variable
                 (iii) do (ii) until t > 1.96

 (2) ADF test:
 (3) Making lagged variables

 Usage:
 (1)  k = detlag(y,p,ioption)
      determine the proper lag in ADF regression:
      model: y(t) = a + a1 y(t-1) + a2 y(t-1) + ... + ap y(t-p) + u(t)
      ioption: decide whether determinstic terms includes or not.
               ioption = 0: no constant
               ioption = 1: constant
               ioption = 2: constant + time trend

 (2) k = detlagnc(y,p,ioption)
      determine the proper lag in the following regression:
      model: y(t) = a + a2 y(t-1) + ... + ap y(t-p) + u(t)
      ioption: decide whether determinstic terms includes or not.
               ioption = 0: no constant
               ioption = 1: constant
               ioption = 2: constant + time trend

 (3) {a1, t, residual} = suladf(y,p,ioption)
     calcaluate slope coefficient and its t-value in ADF regression
     model: y(t) = a + a1 y(t-1) + a2 y(t-1) + ... + ap y(t-p) + u(t)

 (4) {y,x} = lagp(x,p)
     make y(t), y(t-1), y(t-1), ... , y(t-p)
     output: y = y(t)  (t-p-1)x1 matrix
             x = [ y(t-1) y(t-1), ... , y(t-p) ] (t-p-1)x(p+1) matrix

 (5) {y,x} = lagp1(x,p)
     make y(t), y(t-1), ... , y(t-p)
     output: y = y(t)  (t-p-1)x1 matrix
             x = [ y(t-1), ... , y(t-p) ] (t-p-1)x(p) matrix
 (6) {sigm} = nwest(y,p)
     calculate newey-west longrun variance of y(t). P is the maximum bandwidth.
@

proc detlag(s,pp,icoption);
local i,ss,i1,y,x,const, b, resi,s_s,se,t_last, rio,n;
local indx;

n = cols(s);
indx = ones(n,1);
i = 1;
do while i <= n;
ss = s[.,i];

i1 = pp;
do while i1 >= 2;

{y,x} = lagp(ss,i1);
const = ones(rows(y),1);
if icoption == 1; x = const~x; endif;
if icoption == 2; x = const~seqa(1,1,rows(x))~x; endif;
b = inv(x'x)*x'y;
resi = y - x*b;
s_s = resi'resi/(rows(y) - rows(b) );
se  = sqrt(diag(s_s*inv(x'x)));
t_last = abs(b[rows(b),1]/se[rows(se),1]);
if t_last >= 1.96; indx[i,1] = i1; goto rio; endif;

i1 = i1 -1;
endo;
rio:

i = i + 1;
endo;
retp(indx);
endp;

proc detlagnc(s,pp,icoption);
local i,ss,i1,y,x,const, b, resi,s_s,se,t_last, rio,n;
local indx;

n = cols(s);
indx = ones(n,1);
i = 1;
do while i <= n;
ss = s[.,i];

i1 = pp;
do while i1 >= 2;

{y,x} = lagp1(ss,i1);
const = ones(rows(y),1);
if icoption == 1; x = const~x; endif;
b = inv(x'x)*x'y;
resi = y - x*b;
s_s = resi'resi/(rows(y) - rows(b) );
se  = sqrt(diag(s_s*inv(x'x)));
t_last = abs(b[rows(b),1]/se[rows(se),1]);
if t_last >= 1.96; indx[i,1] = i1; goto rio; endif;

i1 = i1 -1;
endo;
rio:

i = i + 1;
endo;
retp(indx);
endp;


proc (2) = lagp(x,p);
local t,i,xx,dx,y,rio;
t = rows(x);

if p == 1;
y = x[2:t,.]; x = x[1:t-1,.]; goto rio; endif;

xx = zeros(t-p,p+1);
dx = zeros(t-p,p-1);

i = 0; do while i <= p;
xx[.,i+1] = x[p+1-i:t-i,.];
i = i + 1; endo;

i = 1; do while i <= p-1;
dx[.,p-i] = xx[.,p-(i-1)] - xx[.,p+1-(i-1)];
i = i + 1; endo;

y = xx[.,1];  x = xx[.,2]~dx;
rio:
retp(y,x); endp;


 proc (3) = suladf(f,p,option);
 local y,x,beta,resi,ss,var_cov,va;
 {y, x} = lagp(f,p);
 if option == 1;  x = x~ones(rows(x),1); endif;
 if option == 2;  x = x~ones(rows(x),1)~seqa(1,1,rows(x)); endif;
 beta = inv(x'x)*x'y;
 resi = y - x*beta;
 ss   = (resi'resi)/(rows(y) - cols(x));
 var_cov = ss*inv(x'x);
 va = (beta[1,1] - 1)/sqrt(var_cov[1,1]);
 retp(beta,va,resi);
 endp;

proc (2) = lagp1(x,p);
local t,i,xx,dx,y,rio;
t = rows(x);
if p == 1; y = x[2:t,.] - x[1:t-1,.]; x = zeros(t-1,1); goto rio; endif;
xx = zeros(t-p,p+1);dx = zeros(t-p,p-1);

i = 0;do while i <= p;
xx[.,i+1] = x[p+1-i:t-i,.];
i = i + 1;endo;

i = 1;do while i <= p-1;
dx[.,p-i] = xx[.,p-(i-1)] - xx[.,p+1-(i-1)];
i = i + 1;endo;

y = xx[.,1] - xx[.,2];
x = dx; rio:
retp(y,x); endp;

 
proc (2) = lagpp(x,p);
local t,i,xx,dx,y,rio;
t = rows(x);

if p == 1;
y = x[2:t,.]; x = x[1:t-1,.]; goto rio; endif;

xx = zeros(t-p,p+1);
dx = zeros(t-p,p-1);

i = 0; do while i <= p;
xx[.,i+1] = x[p+1-i:t-i,.];
i = i + 1; endo;

y = xx[.,1];  x = xx[.,2:cols(xx)];
rio:
retp(y,x); endp;
